// PLIB
#define _SUPPRESS_PLIB_WARNING 1
#include "plib.h"

// For interrupts
#include <xc.h>
#include <sys/attribs.h>

unsigned short capture_time = 0x00FF;

void initCapture1Timer2(){
  // Set up timer 2
  // Afterwards, use ReadTimer2 and WriteTimer2(0)
  OpenTimer2(T2_ON| T2_PS_1_64 | T2_SOURCE_INT, 0xFFFF);
  
  // Set up input capture
  OpenCapture1(IC_EVERY_RISE_EDGE | IC_INT_1CAPTURE | IC_TIMER2_SRC | IC_ON );
  ConfigIntCapture1(IC_INT_ON | IC_INT_PRIOR_3 | IC_INT_SUB_PRIOR_3 );
  INTClearFlag(INT_IC1);
  PPSInput(3, IC1, RPB13);
  mPORTBSetPinsDigitalIn(BIT_13);    //Set port as input
}

float getRPM(){
    return 5357142.0/capture_time;
}

// === IC1 ISR =================================================
// Just grabs what the input capture peripheral saw on Timer2.
// Vector, interrupt priority level, handler
void __ISR(_INPUT_CAPTURE_1_VECTOR, ipl3) IC1Handler(void) 
{ 
    // Restart Timer2
    WriteTimer2(0);
    // Store the timer value of the capture event into CaptureTime variable
    // Do a low-pass filter to avoid jumping around too much
    capture_time = 7*(capture_time>>3) + (mIC1ReadCapture()>>3);
    // Record RPM
    //rpm = 
    // Clear the interrupt flag
    mIC1ClearIntFlag();
}